/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.cvut.kbss.bodm.compositekey;

import java.io.Serializable;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.IdClass;
import javax.persistence.SequenceGenerator;

/**
 *
 * @author user
 */
@Entity
@IdClass(value=DepartmentEntity.DepartmentId.class)
public class DepartmentEntity implements Serializable{
    @Id
    @GeneratedValue(generator="COM_SEQ", strategy= GenerationType.AUTO)
    @SequenceGenerator(name="COM_SEQ", sequenceName="COM_SEQ", allocationSize=1)
    protected Long companyId;
    @Id
    @GeneratedValue(generator="DEP_SEQ", strategy= GenerationType.AUTO)
    @SequenceGenerator(name="DEP_SEQ", sequenceName="DEP_SEQ", allocationSize=1)
    protected Long id;
    
    protected String name;
    
    protected String address;

    public Long getCompanyId() {
        return companyId;
    }

    public void setCompanyId(Long companyId) {
        this.companyId = companyId;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getAddress() {
        return address;
    }

    public void setAddress(String address) {
        this.address = address;
    }

    
    /**
     * IdClass for the department entity class that has a composite primary key.
     * It is not nessecery to make the composite id class an inner class of the entity.
     */
    public static class DepartmentId implements Serializable{
        // The names and types of the attributes of the IdClass must be the same as
        // the names and types of the attiributes with the Id annotation in the
        // Entity class.
        @GeneratedValue(generator="COM_SEQ", strategy= GenerationType.AUTO)
        @SequenceGenerator(name="COM_SEQ", sequenceName="COM_SEQ", allocationSize=1)
        protected Long companyId;
        @GeneratedValue(generator="DEP_SEQ", strategy= GenerationType.AUTO)
        @SequenceGenerator(name="DEP_SEQ", sequenceName="DEP_SEQ", allocationSize=1)
        protected Long id;

        /**
         * The IdClass needs
         */
        public DepartmentId() {
        }
        
        
        public Long getCompanyId() {
            return companyId;
        }

        public void setCompanyId(Long companyId) {
            this.companyId = companyId;
        }

        public Long getId() {
            return id;
        }

        public void setId(Long id) {
            this.id = id;
        }
        
        // The IdClass must also ovveride their equals and hashCode methods.

        @Override
        public int hashCode() {
            int hash = 5;
            hash = 97 * hash + (this.companyId != null ? this.companyId.hashCode() : 0);
            hash = 97 * hash + (this.id != null ? this.id.hashCode() : 0);
            return hash;
        }

        @Override
        public boolean equals(Object obj) {
            if (obj == null) {
                return false;
            }
            if (getClass() != obj.getClass()) {
                return false;
            }
            final DepartmentId other = (DepartmentId) obj;
            if (this.companyId != other.companyId && (this.companyId == null || !this.companyId.equals(other.companyId))) {
                return false;
            }
            if (this.id != other.id && (this.id == null || !this.id.equals(other.id))) {
                return false;
            }
            return true;
        }
        
        
        
    }
    
}
