/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.cvut.kbss.bodm.manytomany;

import cz.cvut.kbss.dao.GenericDAOIface;
import cz.cvut.kbss.dao.GenericDAOImpl;
import cz.cvut.kbss.jpautils.JPAUtility;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.persistence.EntityManager;

/**
 *
 * @author user
 */
public class ManyToManyRelationExperiment {
    
    public static void main(String[] args) {
        testFindByDAOMethod();
    }
    
    public static void createNewStudentNewCourseAndEnrolStudentInCourse(){
        GenericDAOIface dao = GenericDAOImpl.getGenericDAO();
        dao.removeAll(Student.class);
        dao.removeAll(Course.class);
        Student s = new Student();
        s.setFirstname("Petr");
        s.setSecondname("Cech");
        dao.saveEntity(s);
        System.out.println(dao.getAll(Student.class).get(0).getVisitingCourses().size());
        Course course = new Course();
        course.setCourseName("Math");
        course.setCredits(6);
        dao.saveEntity(course);
        
        enrolinCourse(s, course);
        for(Student ss : dao.getAll(Student.class)){
            for(Course c : ss.getVisitingCourses()){
                System.out.println(c.getCourseName() + " = " + c.getCredits());
            }
        }
    }
    
    public static void enrolinCourse(Student s, Course c){
       EntityManager em = JPAUtility.createNewEntityManager();
       try{
       em.getTransaction().begin();
           Student managedStudent = em.merge(s);
           Course managedCourse = em.merge(c);
           
           List<Course> courses = managedStudent.getVisitingCourses();
           if(courses == null){
               courses = new ArrayList<Course>();
               managedStudent.setVisitingCourses(courses);
           }
           courses.add(managedCourse);
       em.getTransaction().commit();
       }catch(Exception e){
           em.getTransaction().rollback();
           Logger.getLogger(ManyToManyRelationExperiment.class.getName()).log(Level.INFO, "Could not enrol in course!", e);
       }
    }
    
    public static void experimentUnique(){
        GenericDAOIface dao = GenericDAOImpl.getGenericDAO();
        dao.removeAll(Student.class);
        Student std1 = new Student();
        std1.setFirstname("Mara");
        std1.setFirstname("Magdalena");
        std1.setAlternativeId("std1");
        
        dao.saveEntity(std1);
        
        std1 = new Student();
        std1.setFirstname("Mara");
        std1.setFirstname("Magdalena");
        std1.setAlternativeId("std1");
        EntityManager em = JPAUtility.createNewEntityManager();
        em.getTransaction().begin();
        std1 = em.merge(std1);
        std1.setFirstname("Maria");
        em.getTransaction().commit();
    }
    
    public static void testFindByDAOMethod(){
        GenericDAOIface dao = GenericDAOImpl.getGenericDAO();
        dao.removeAll(Student.class);
        Student std1 = new Student();
        std1.setFirstname("Mara");
        std1.setSecondname("Magdalena");
        std1.setAlternativeId("std");
        
        dao.saveEntity(std1);
        
        std1 = new Student();
        std1.setFirstname("Tara");
        std1.setSecondname("Gabova");
        std1.setAlternativeId("std2");
        dao.saveEntity(std1);
        
        std1 = new Student();
        std1.setFirstname("Student1");
        std1.setSecondname("Student1");
        dao.saveEntity(std1);
        
        std1 = new Student();
        std1.setFirstname("Student2");
        std1.setSecondname("Student2");
        dao.saveEntity(std1);
        
        String altId = "std";
        Student s = dao.findBy(Student.class, "alternativeId", altId);
        if(s == null){
            std1 = new Student();
            std1.setFirstname("Petr");
            std1.setSecondname("Rychly");
            std1.setAlternativeId("std");
            dao.mergeEntity(std1);
        }else{
            System.out.println("student already exists - " + s.getAlternativeId() + " : " + s.getFirstname() + ", " + s.getSecondname());
        }
    }
}
