/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.cvut.kbss.bodm.manytomany;

import java.io.Serializable;
import java.util.List;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToMany;
import javax.persistence.Table;
import javax.persistence.UniqueConstraint;

/**
 *
 * @author user
 */
@Entity
//@Table(uniqueConstraints={@UniqueConstraint(columnNames={"salternativeId"})})
public class Student implements Serializable{
    @Id
    @GeneratedValue
    protected Long id;
    
    @Column(unique=true)
    protected String alternativeId;
    
    protected String firstname;
    
    protected String secondname;

    // In JPA the many to many relation is not bi directional. Unidirectional 
    // ManyToMany relation is defined as shown below. A bidirectional ManyToMany
    // is modeled using by adding a @ManyToMany annotation on the other end of the
    // relation. For an example of adding the other direction of a ManyToMany 
    // relation see at the Course.visitingStudents. 
    @ManyToMany
    @JoinTable(name="STUD_VISIT_COURSE", 
            joinColumns={@JoinColumn(name="STUD_ID", referencedColumnName="ID")}, 
            inverseJoinColumns={@JoinColumn(name="COURSE_ID", referencedColumnName="ID")})
    protected List<Course> visitingCourses;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getFirstname() {
        return firstname;
    }

    public void setFirstname(String firstname) {
        this.firstname = firstname;
    }

    public String getSecondname() {
        return secondname;
    }

    public void setSecondname(String secondname) {
        this.secondname = secondname;
    }

    public List<Course> getVisitingCourses() {
        return visitingCourses;
    }

    public void setVisitingCourses(List<Course> visitingCourses) {
        this.visitingCourses = visitingCourses;
    }

    public String getAlternativeId() {
        return alternativeId;
    }

    public void setAlternativeId(String alternativeId) {
        this.alternativeId = alternativeId;
    }
    
    
    
}
